library textstyle_extensions;

import 'dart:ui';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

extension TextStyleExtensions on TextStyle {
  TextStyle get light => weight(FontWeight.w200);

  TextStyle get regular => weight(FontWeight.normal);

  TextStyle get semiBold => weight(FontWeight.w500);

  TextStyle get bold => weight(FontWeight.bold);

  TextStyle get italic => style(FontStyle.italic);

  TextStyle get underline => textDecoration(TextDecoration.underline);

  TextStyle get lineThrough => textDecoration(TextDecoration.lineThrough);

  TextStyle get overline => textDecoration(TextDecoration.overline);

  TextStyle get normal => style(FontStyle.normal);

  TextStyle textColor(Color v) => copyWith(color: v);

  TextStyle textBackgroundColor(Color v) => copyWith(backgroundColor: v);

  TextStyle size(double v) => copyWith(fontSize: v);

  TextStyle scale(double v) => copyWith(fontSize: fontSize * v);

  TextStyle weight(FontWeight v) => copyWith(fontWeight: v);

  TextStyle style(FontStyle v) => copyWith(fontStyle: v);

  TextStyle letterSpace(double v) => copyWith(letterSpacing: v);

  TextStyle wordSpace(double v) => copyWith(wordSpacing: v);

  TextStyle baseline(TextBaseline v) => copyWith(textBaseline: v);

  TextStyle textHeight(double v) => copyWith(height: v);

  TextStyle textLocale(Locale v) => copyWith(locale: v);

  TextStyle textForeground(Paint v) => copyWith(foreground: v);

  TextStyle textBackground(Paint v) => copyWith(background: v);

  TextStyle textShadows(List<Shadow> v) => copyWith(shadows: v);

  TextStyle textFeatures(List<FontFeature> v) => copyWith(fontFeatures: v);

  TextStyle textDecoration(TextDecoration v, {Color color, TextDecorationStyle style, double thickness}) =>
      copyWith(decoration: v, decorationColor: color, decorationStyle: style, decorationThickness: thickness);
}
